<!DOCTYPE html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <title>Dashboard for /vagrant/src</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href="_css/bootstrap.min.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/nv.d3.min.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/style.css?v=9.2.26" rel="stylesheet" type="text/css">
  <link href="_css/custom.css" rel="stylesheet" type="text/css">
 </head>
 <body>
  <header>
   <div class="container-fluid">
    <div class="row">
     <div class="col-md-12">
      <nav aria-label="breadcrumb">
       <ol class="breadcrumb">
         <li class="breadcrumb-item"><a href="index.html">/vagrant/src</a></li>
         <li class="breadcrumb-item active">(Dashboard)</li>

       </ol>
      </nav>
     </div>
    </div>
   </div>
  </header>
  <div class="container-fluid">
   <div class="row">
    <div class="col-md-12">
     <h2>Classes</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="classCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="classComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#17">App\Command\OpenfoodfactsCommand</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserCreateCommand.php.html#13">App\Command\UserCreateCommand</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#12">App\Command\UserResetPasswordCommand</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#19">App\Controller\ProductPresenceController</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#19">App\Controller\ResettingController</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="DataFixtures/AppFixtures.php.html#14">App\DataFixtures\AppFixtures</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#15">App\Entity\Brand</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#15">App\Entity\Product</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#16">App\Entity\ProductPresence</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/NewPasswordType.php.html#11">App\Form\NewPasswordType</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/PasswordChangeType.php.html#12">App\Form\PasswordChangeType</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/PasswordRequestType.php.html#10">App\Form\PasswordRequestType</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceFilterType.php.html#11">App\Form\ProductPresenceFilterType</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceType.php.html#14">App\Form\ProductPresenceType</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Repository/ProductPresenceRepository.php.html#22">App\Repository\ProductPresenceRepository</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/DefaultController.php.html#11">App\Controller\DefaultController</a></td><td class="text-right">8%</td></tr>
       <tr><td><a href="Entity/User.php.html#21">App\Entity\User</a></td><td class="text-right">16%</td></tr>
       <tr><td><a href="Repository/UserRepository.php.html#20">App\Repository\UserRepository</a></td><td class="text-right">16%</td></tr>
       <tr><td><a href="Repository/PantryRepository.php.html#14">App\Repository\PantryRepository</a></td><td class="text-right">20%</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#15">App\Entity\Pantry</a></td><td class="text-right">56%</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#11">App\Security\Voters\PantryVoter</a></td><td class="text-right">71%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Entity/User.php.html#21">App\Entity\User</a></td><td class="text-right">670</td></tr>
       <tr><td><a href="Entity/Product.php.html#15">App\Entity\Product</a></td><td class="text-right">342</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#19">App\Controller\ResettingController</a></td><td class="text-right">156</td></tr>
       <tr><td><a href="Entity/Brand.php.html#15">App\Entity\Brand</a></td><td class="text-right">110</td></tr>
       <tr><td><a href="Command/UserCreateCommand.php.html#13">App\Command\UserCreateCommand</a></td><td class="text-right">72</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#19">App\Controller\ProductPresenceController</a></td><td class="text-right">72</td></tr>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#17">App\Command\OpenfoodfactsCommand</a></td><td class="text-right">42</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#12">App\Command\UserResetPasswordCommand</a></td><td class="text-right">42</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#15">App\Entity\Pantry</a></td><td class="text-right">37</td></tr>
       <tr><td><a href="Repository/ProductPresenceRepository.php.html#22">App\Repository\ProductPresenceRepository</a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Controller/DefaultController.php.html#11">App\Controller\DefaultController</a></td><td class="text-right">16</td></tr>
       <tr><td><a href="DataFixtures/AppFixtures.php.html#14">App\DataFixtures\AppFixtures</a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#11">App\Security\Voters\PantryVoter</a></td><td class="text-right">10</td></tr>
       <tr><td><a href="Repository/UserRepository.php.html#20">App\Repository\UserRepository</a></td><td class="text-right">8</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-12">
     <h2>Methods</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="methodCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="methodComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#31"><abbr title="App\Command\OpenfoodfactsCommand::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#38"><abbr title="App\Command\OpenfoodfactsCommand::configure">configure</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#45"><abbr title="App\Command\OpenfoodfactsCommand::execute">execute</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserCreateCommand.php.html#26"><abbr title="App\Command\UserCreateCommand::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserCreateCommand.php.html#33"><abbr title="App\Command\UserCreateCommand::configure">configure</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserCreateCommand.php.html#39"><abbr title="App\Command\UserCreateCommand::execute">execute</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#24"><abbr title="App\Command\UserResetPasswordCommand::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#31"><abbr title="App\Command\UserResetPasswordCommand::configure">configure</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#37"><abbr title="App\Command\UserResetPasswordCommand::execute">execute</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/DefaultController.php.html#24"><abbr title="App\Controller\DefaultController::saveUserPreferences">saveUserPreferences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/DefaultController.php.html#38"><abbr title="App\Controller\DefaultController::getUserPreferences">getUserPreferences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#22"><abbr title="App\Controller\ProductPresenceController::index">index</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#44"><abbr title="App\Controller\ProductPresenceController::new">new</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#67"><abbr title="App\Controller\ProductPresenceController::remove">remove</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#24"><abbr title="App\Controller\ResettingController::resetPassword">resetPassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#52"><abbr title="App\Controller\ResettingController::resetPasswordCheck">resetPasswordCheck</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#93"><abbr title="App\Controller\ResettingController::changePassword">changePassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Controller/SecurityController.php.html#36"><abbr title="App\Controller\SecurityController::logout">logout</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="DataFixtures/AppFixtures.php.html#18"><abbr title="App\DataFixtures\AppFixtures::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="DataFixtures/AppFixtures.php.html#23"><abbr title="App\DataFixtures\AppFixtures::load">load</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#43"><abbr title="App\Entity\Brand::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#49"><abbr title="App\Entity\Brand::getId">getId</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#54"><abbr title="App\Entity\Brand::getName">getName</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#59"><abbr title="App\Entity\Brand::setName">setName</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#69"><abbr title="App\Entity\Brand::getProducts">getProducts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#74"><abbr title="App\Entity\Brand::addProduct">addProduct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Brand.php.html#84"><abbr title="App\Entity\Brand::removeProduct">removeProduct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#111"><abbr title="App\Entity\Pantry::removeOwner">removeOwner</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#121"><abbr title="App\Entity\Pantry::getProductPeesences">getProductPeesences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#126"><abbr title="App\Entity\Pantry::addProductPeesence">addProductPeesence</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#136"><abbr title="App\Entity\Pantry::removeProductPeesence">removeProductPeesence</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#67"><abbr title="App\Entity\Product::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#74"><abbr title="App\Entity\Product::__toString">__toString</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#82"><abbr title="App\Entity\Product::getId">getId</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#87"><abbr title="App\Entity\Product::getName">getName</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#92"><abbr title="App\Entity\Product::setName">setName</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#99"><abbr title="App\Entity\Product::getBarcode">getBarcode</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#104"><abbr title="App\Entity\Product::setBarcode">setBarcode</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#111"><abbr title="App\Entity\Product::getOpenfoodfactsURL">getOpenfoodfactsURL</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#116"><abbr title="App\Entity\Product::setOpenfoodfactsURL">setOpenfoodfactsURL</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#123"><abbr title="App\Entity\Product::getBrand">getBrand</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#128"><abbr title="App\Entity\Product::setBrand">setBrand</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#138"><abbr title="App\Entity\Product::getProductPeesences">getProductPeesences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#143"><abbr title="App\Entity\Product::addProductPeesence">addProductPeesence</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/Product.php.html#153"><abbr title="App\Entity\Product::removeProductPeesence">removeProductPeesence</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#59"><abbr title="App\Entity\ProductPresence::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#64"><abbr title="App\Entity\ProductPresence::getId">getId</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#69"><abbr title="App\Entity\ProductPresence::getQuantity">getQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#74"><abbr title="App\Entity\ProductPresence::setQuantity">setQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#81"><abbr title="App\Entity\ProductPresence::getExpiration">getExpiration</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#86"><abbr title="App\Entity\ProductPresence::setExpiration">setExpiration</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#93"><abbr title="App\Entity\ProductPresence::getProduct">getProduct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#98"><abbr title="App\Entity\ProductPresence::setProduct">setProduct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#105"><abbr title="App\Entity\ProductPresence::getPantry">getPantry</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/ProductPresence.php.html#110"><abbr title="App\Entity\ProductPresence::setPantry">setPantry</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#122"><abbr title="App\Entity\User::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#134"><abbr title="App\Entity\User::getEmail">getEmail</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#139"><abbr title="App\Entity\User::setEmail">setEmail</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#151"><abbr title="App\Entity\User::setPassword">setPassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#158"><abbr title="App\Entity\User::getPlainPassword">getPlainPassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#163"><abbr title="App\Entity\User::setPlainPassword">setPlainPassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#170"><abbr title="App\Entity\User::getPasswordRequestToken">getPasswordRequestToken</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#175"><abbr title="App\Entity\User::setPasswordRequestToken">setPasswordRequestToken</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#191"><abbr title="App\Entity\User::setRoles">setRoles</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#222"><abbr title="App\Entity\User::setUsername">setUsername</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#234"><abbr title="App\Entity\User::setFirstname">setFirstname</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#246"><abbr title="App\Entity\User::setLastname">setLastname</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#256"><abbr title="App\Entity\User::getPreferences">getPreferences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#265"><abbr title="App\Entity\User::setPreferences">setPreferences</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#272"><abbr title="App\Entity\User::getCreated">getCreated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#277"><abbr title="App\Entity\User::setCreated">setCreated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#284"><abbr title="App\Entity\User::getUpdated">getUpdated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#289"><abbr title="App\Entity\User::setUpdated">setUpdated</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#296"><abbr title="App\Entity\User::getLastLogin">getLastLogin</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#301"><abbr title="App\Entity\User::setLastLogin">setLastLogin</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#311"><abbr title="App\Entity\User::getPantries">getPantries</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#316"><abbr title="App\Entity\User::addPantry">addPantry</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Entity/User.php.html#326"><abbr title="App\Entity\User::removePantry">removePantry</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/NewPasswordType.php.html#13"><abbr title="App\Form\NewPasswordType::buildForm">buildForm</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/PasswordChangeType.php.html#14"><abbr title="App\Form\PasswordChangeType::buildForm">buildForm</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/PasswordRequestType.php.html#12"><abbr title="App\Form\PasswordRequestType::buildForm">buildForm</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceFilterType.php.html#13"><abbr title="App\Form\ProductPresenceFilterType::buildForm">buildForm</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceFilterType.php.html#20"><abbr title="App\Form\ProductPresenceFilterType::configureOptions">configureOptions</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceType.php.html#16"><abbr title="App\Form\ProductPresenceType::buildForm">buildForm</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Form/ProductPresenceType.php.html#37"><abbr title="App\Form\ProductPresenceType::configureOptions">configureOptions</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Repository/PantryRepository.php.html#22"><abbr title="App\Repository\PantryRepository::findAllByUser">findAllByUser</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Repository/ProductPresenceRepository.php.html#24"><abbr title="App\Repository\ProductPresenceRepository::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Repository/ProductPresenceRepository.php.html#29"><abbr title="App\Repository\ProductPresenceRepository::findAllByUser">findAllByUser</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Repository/UserRepository.php.html#30"><abbr title="App\Repository\UserRepository::upgradePassword">upgradePassword</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#27"><abbr title="App\Security\Voters\PantryVoter::voteOnAttribute">voteOnAttribute</abbr></a></td><td class="text-right">60%</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#43"><abbr title="App\Security\Voters\PantryVoter::canManage">canManage</abbr></a></td><td class="text-right">75%</td></tr>
       <tr><td><a href="Controller/PantryController.php.html#75"><abbr title="App\Controller\PantryController::edit">edit</abbr></a></td><td class="text-right">80%</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#15"><abbr title="App\Security\Voters\PantryVoter::supports">supports</abbr></a></td><td class="text-right">80%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Command/UserCreateCommand.php.html#39"><abbr title="App\Command\UserCreateCommand::execute">execute</abbr></a></td><td class="text-right">42</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#52"><abbr title="App\Controller\ResettingController::resetPasswordCheck">resetPasswordCheck</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="Command/OpenfoodfactsCommand.php.html#45"><abbr title="App\Command\OpenfoodfactsCommand::execute">execute</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Command/UserResetPasswordCommand.php.html#37"><abbr title="App\Command\UserResetPasswordCommand::execute">execute</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#24"><abbr title="App\Controller\ResettingController::resetPassword">resetPassword</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#44"><abbr title="App\Controller\ProductPresenceController::new">new</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#67"><abbr title="App\Controller\ProductPresenceController::remove">remove</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Controller/ResettingController.php.html#93"><abbr title="App\Controller\ResettingController::changePassword">changePassword</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Entity/Brand.php.html#84"><abbr title="App\Entity\Brand::removeProduct">removeProduct</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#136"><abbr title="App\Entity\Pantry::removeProductPeesence">removeProductPeesence</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Entity/Product.php.html#153"><abbr title="App\Entity\Product::removeProductPeesence">removeProductPeesence</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Repository/ProductPresenceRepository.php.html#29"><abbr title="App\Repository\ProductPresenceRepository::findAllByUser">findAllByUser</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Controller/DefaultController.php.html#38"><abbr title="App\Controller\DefaultController::getUserPreferences">getUserPreferences</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Controller/ProductPresenceController.php.html#22"><abbr title="App\Controller\ProductPresenceController::index">index</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="DataFixtures/AppFixtures.php.html#23"><abbr title="App\DataFixtures\AppFixtures::load">load</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/Brand.php.html#74"><abbr title="App\Entity\Brand::addProduct">addProduct</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/Pantry.php.html#126"><abbr title="App\Entity\Pantry::addProductPeesence">addProductPeesence</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/Product.php.html#74"><abbr title="App\Entity\Product::__toString">__toString</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/Product.php.html#143"><abbr title="App\Entity\Product::addProductPeesence">addProductPeesence</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/User.php.html#316"><abbr title="App\Entity\User::addPantry">addPantry</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Entity/User.php.html#326"><abbr title="App\Entity\User::removePantry">removePantry</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Repository/UserRepository.php.html#30"><abbr title="App\Repository\UserRepository::upgradePassword">upgradePassword</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#27"><abbr title="App\Security\Voters\PantryVoter::voteOnAttribute">voteOnAttribute</abbr></a></td><td class="text-right">3</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#43"><abbr title="App\Security\Voters\PantryVoter::canManage">canManage</abbr></a></td><td class="text-right">3</td></tr>
       <tr><td><a href="Controller/PantryController.php.html#75"><abbr title="App\Controller\PantryController::edit">edit</abbr></a></td><td class="text-right">3</td></tr>
       <tr><td><a href="Security/Voters/PantryVoter.php.html#15"><abbr title="App\Security\Voters\PantryVoter::supports">supports</abbr></a></td><td class="text-right">3</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <footer>
    <hr/>
    <p>
     <small>Generated by <a href="https://github.com/sebastianbergmann/php-code-coverage" target="_top">php-code-coverage 9.2.26</a> using <a href="https://secure.php.net/" target="_top">PHP 8.1.16</a> at Sat Mar 11 11:01:13 UTC 2023.</small>
    </p>
   </footer>
  </div>
  <script src="_js/jquery.min.js?v=9.2.26" type="text/javascript"></script>
  <script src="_js/d3.min.js?v=9.2.26" type="text/javascript"></script>
  <script src="_js/nv.d3.min.js?v=9.2.26" type="text/javascript"></script>
  <script type="text/javascript">
$(document).ready(function() {
  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#classCoverageDistribution svg')
      .datum(getCoverageDistributionData([15,1,2,1,0,0,1,0,1,0,2,4], "Class Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#methodCoverageDistribution svg')
      .datum(getCoverageDistributionData([89,0,0,0,0,0,0,1,1,2,0,28], "Method Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getCoverageDistributionData(data, label) {
    var labels = [
      '0%',
      '0-10%',
      '10-20%',
      '20-30%',
      '30-40%',
      '40-50%',
      '50-60%',
      '60-70%',
      '70-80%',
      '80-90%',
      '90-100%',
      '100%'
    ];
    var values = [];
    $.each(labels, function(key) {
      values.push({x: labels[key], y: data[key]});
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Cyclomatic Complexity');

    d3.select('#classComplexity svg')
      .datum(getComplexityData([[0,6,"<a href=\"Command\/OpenfoodfactsCommand.php.html#17\">App\\Command\\OpenfoodfactsCommand<\/a>"],[0,8,"<a href=\"Command\/UserCreateCommand.php.html#13\">App\\Command\\UserCreateCommand<\/a>"],[0,6,"<a href=\"Command\/UserResetPasswordCommand.php.html#12\">App\\Command\\UserResetPasswordCommand<\/a>"],[100,0,"<a href=\"Controller\/BaseController.php.html#19\">App\\Controller\\BaseController<\/a>"],[8.333333333333332,4,"<a href=\"Controller\/DefaultController.php.html#11\">App\\Controller\\DefaultController<\/a>"],[95.45454545454545,9,"<a href=\"Controller\/PantryController.php.html#15\">App\\Controller\\PantryController<\/a>"],[0,8,"<a href=\"Controller\/ProductPresenceController.php.html#19\">App\\Controller\\ProductPresenceController<\/a>"],[0,12,"<a href=\"Controller\/ResettingController.php.html#19\">App\\Controller\\ResettingController<\/a>"],[91.66666666666666,2,"<a href=\"Controller\/SecurityController.php.html#12\">App\\Controller\\SecurityController<\/a>"],[0,3,"<a href=\"DataFixtures\/AppFixtures.php.html#14\">App\\DataFixtures\\AppFixtures<\/a>"],[0,10,"<a href=\"Entity\/Brand.php.html#15\">App\\Entity\\Brand<\/a>"],[56.00000000000001,16,"<a href=\"Entity\/Pantry.php.html#15\">App\\Entity\\Pantry<\/a>"],[0,18,"<a href=\"Entity\/Product.php.html#15\">App\\Entity\\Product<\/a>"],[0,10,"<a href=\"Entity\/ProductPresence.php.html#16\">App\\Entity\\ProductPresence<\/a>"],[16.3265306122449,33,"<a href=\"Entity\/User.php.html#21\">App\\Entity\\User<\/a>"],[0,1,"<a href=\"Form\/NewPasswordType.php.html#11\">App\\Form\\NewPasswordType<\/a>"],[100,2,"<a href=\"Form\/PantryType.php.html#10\">App\\Form\\PantryType<\/a>"],[0,1,"<a href=\"Form\/PasswordChangeType.php.html#12\">App\\Form\\PasswordChangeType<\/a>"],[0,1,"<a href=\"Form\/PasswordRequestType.php.html#10\">App\\Form\\PasswordRequestType<\/a>"],[0,2,"<a href=\"Form\/ProductPresenceFilterType.php.html#11\">App\\Form\\ProductPresenceFilterType<\/a>"],[0,2,"<a href=\"Form\/ProductPresenceType.php.html#14\">App\\Form\\ProductPresenceType<\/a>"],[100,3,"<a href=\"Form\/UserLoginType.php.html#11\">App\\Form\\UserLoginType<\/a>"],[100,0,"<a href=\"Kernel.php.html#17\">App\\Kernel<\/a>"],[20,2,"<a href=\"Repository\/PantryRepository.php.html#14\">App\\Repository\\PantryRepository<\/a>"],[0,4,"<a href=\"Repository\/ProductPresenceRepository.php.html#22\">App\\Repository\\ProductPresenceRepository<\/a>"],[16.666666666666664,3,"<a href=\"Repository\/UserRepository.php.html#20\">App\\Repository\\UserRepository<\/a>"],[71.42857142857143,9,"<a href=\"Security\/Voters\/PantryVoter.php.html#11\">App\\Security\\Voters\\PantryVoter<\/a>"]], 'Class Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Method Complexity');

    d3.select('#methodComplexity svg')
      .datum(getComplexityData([[0,1,"<a href=\"Command\/OpenfoodfactsCommand.php.html#31\">App\\Command\\OpenfoodfactsCommand::__construct<\/a>"],[0,1,"<a href=\"Command\/OpenfoodfactsCommand.php.html#38\">App\\Command\\OpenfoodfactsCommand::configure<\/a>"],[0,4,"<a href=\"Command\/OpenfoodfactsCommand.php.html#45\">App\\Command\\OpenfoodfactsCommand::execute<\/a>"],[0,1,"<a href=\"Command\/UserCreateCommand.php.html#26\">App\\Command\\UserCreateCommand::__construct<\/a>"],[0,1,"<a href=\"Command\/UserCreateCommand.php.html#33\">App\\Command\\UserCreateCommand::configure<\/a>"],[0,6,"<a href=\"Command\/UserCreateCommand.php.html#39\">App\\Command\\UserCreateCommand::execute<\/a>"],[0,1,"<a href=\"Command\/UserResetPasswordCommand.php.html#24\">App\\Command\\UserResetPasswordCommand::__construct<\/a>"],[0,1,"<a href=\"Command\/UserResetPasswordCommand.php.html#31\">App\\Command\\UserResetPasswordCommand::configure<\/a>"],[0,4,"<a href=\"Command\/UserResetPasswordCommand.php.html#37\">App\\Command\\UserResetPasswordCommand::execute<\/a>"],[100,1,"<a href=\"Controller\/DefaultController.php.html#16\">App\\Controller\\DefaultController::homepage<\/a>"],[0,1,"<a href=\"Controller\/DefaultController.php.html#24\">App\\Controller\\DefaultController::saveUserPreferences<\/a>"],[0,2,"<a href=\"Controller\/DefaultController.php.html#38\">App\\Controller\\DefaultController::getUserPreferences<\/a>"],[100,1,"<a href=\"Controller\/PantryController.php.html#18\">App\\Controller\\PantryController::index<\/a>"],[100,3,"<a href=\"Controller\/PantryController.php.html#45\">App\\Controller\\PantryController::new<\/a>"],[80,3,"<a href=\"Controller\/PantryController.php.html#75\">App\\Controller\\PantryController::edit<\/a>"],[100,2,"<a href=\"Controller\/PantryController.php.html#94\">App\\Controller\\PantryController::delete<\/a>"],[0,2,"<a href=\"Controller\/ProductPresenceController.php.html#22\">App\\Controller\\ProductPresenceController::index<\/a>"],[0,3,"<a href=\"Controller\/ProductPresenceController.php.html#44\">App\\Controller\\ProductPresenceController::new<\/a>"],[0,3,"<a href=\"Controller\/ProductPresenceController.php.html#67\">App\\Controller\\ProductPresenceController::remove<\/a>"],[0,4,"<a href=\"Controller\/ResettingController.php.html#24\">App\\Controller\\ResettingController::resetPassword<\/a>"],[0,5,"<a href=\"Controller\/ResettingController.php.html#52\">App\\Controller\\ResettingController::resetPasswordCheck<\/a>"],[0,3,"<a href=\"Controller\/ResettingController.php.html#93\">App\\Controller\\ResettingController::changePassword<\/a>"],[100,1,"<a href=\"Controller\/SecurityController.php.html#17\">App\\Controller\\SecurityController::login<\/a>"],[0,1,"<a href=\"Controller\/SecurityController.php.html#36\">App\\Controller\\SecurityController::logout<\/a>"],[0,1,"<a href=\"DataFixtures\/AppFixtures.php.html#18\">App\\DataFixtures\\AppFixtures::__construct<\/a>"],[0,2,"<a href=\"DataFixtures\/AppFixtures.php.html#23\">App\\DataFixtures\\AppFixtures::load<\/a>"],[0,1,"<a href=\"Entity\/Brand.php.html#43\">App\\Entity\\Brand::__construct<\/a>"],[0,1,"<a href=\"Entity\/Brand.php.html#49\">App\\Entity\\Brand::getId<\/a>"],[0,1,"<a href=\"Entity\/Brand.php.html#54\">App\\Entity\\Brand::getName<\/a>"],[0,1,"<a href=\"Entity\/Brand.php.html#59\">App\\Entity\\Brand::setName<\/a>"],[0,1,"<a href=\"Entity\/Brand.php.html#69\">App\\Entity\\Brand::getProducts<\/a>"],[0,2,"<a href=\"Entity\/Brand.php.html#74\">App\\Entity\\Brand::addProduct<\/a>"],[0,3,"<a href=\"Entity\/Brand.php.html#84\">App\\Entity\\Brand::removeProduct<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#58\">App\\Entity\\Pantry::__construct<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#65\">App\\Entity\\Pantry::getId<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#70\">App\\Entity\\Pantry::getName<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#75\">App\\Entity\\Pantry::setName<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#82\">App\\Entity\\Pantry::isEnabled<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#87\">App\\Entity\\Pantry::setEnabled<\/a>"],[100,1,"<a href=\"Entity\/Pantry.php.html#97\">App\\Entity\\Pantry::getOwners<\/a>"],[100,2,"<a href=\"Entity\/Pantry.php.html#102\">App\\Entity\\Pantry::addOwner<\/a>"],[0,1,"<a href=\"Entity\/Pantry.php.html#111\">App\\Entity\\Pantry::removeOwner<\/a>"],[0,1,"<a href=\"Entity\/Pantry.php.html#121\">App\\Entity\\Pantry::getProductPeesences<\/a>"],[0,2,"<a href=\"Entity\/Pantry.php.html#126\">App\\Entity\\Pantry::addProductPeesence<\/a>"],[0,3,"<a href=\"Entity\/Pantry.php.html#136\">App\\Entity\\Pantry::removeProductPeesence<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#67\">App\\Entity\\Product::__construct<\/a>"],[0,2,"<a href=\"Entity\/Product.php.html#74\">App\\Entity\\Product::__toString<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#82\">App\\Entity\\Product::getId<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#87\">App\\Entity\\Product::getName<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#92\">App\\Entity\\Product::setName<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#99\">App\\Entity\\Product::getBarcode<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#104\">App\\Entity\\Product::setBarcode<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#111\">App\\Entity\\Product::getOpenfoodfactsURL<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#116\">App\\Entity\\Product::setOpenfoodfactsURL<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#123\">App\\Entity\\Product::getBrand<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#128\">App\\Entity\\Product::setBrand<\/a>"],[0,1,"<a href=\"Entity\/Product.php.html#138\">App\\Entity\\Product::getProductPeesences<\/a>"],[0,2,"<a href=\"Entity\/Product.php.html#143\">App\\Entity\\Product::addProductPeesence<\/a>"],[0,3,"<a href=\"Entity\/Product.php.html#153\">App\\Entity\\Product::removeProductPeesence<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#59\">App\\Entity\\ProductPresence::__construct<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#64\">App\\Entity\\ProductPresence::getId<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#69\">App\\Entity\\ProductPresence::getQuantity<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#74\">App\\Entity\\ProductPresence::setQuantity<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#81\">App\\Entity\\ProductPresence::getExpiration<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#86\">App\\Entity\\ProductPresence::setExpiration<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#93\">App\\Entity\\ProductPresence::getProduct<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#98\">App\\Entity\\ProductPresence::setProduct<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#105\">App\\Entity\\ProductPresence::getPantry<\/a>"],[0,1,"<a href=\"Entity\/ProductPresence.php.html#110\">App\\Entity\\ProductPresence::setPantry<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#122\">App\\Entity\\User::__construct<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#129\">App\\Entity\\User::getId<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#134\">App\\Entity\\User::getEmail<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#139\">App\\Entity\\User::setEmail<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#146\">App\\Entity\\User::getPassword<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#151\">App\\Entity\\User::setPassword<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#158\">App\\Entity\\User::getPlainPassword<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#163\">App\\Entity\\User::setPlainPassword<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#170\">App\\Entity\\User::getPasswordRequestToken<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#175\">App\\Entity\\User::setPasswordRequestToken<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#182\">App\\Entity\\User::getRoles<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#191\">App\\Entity\\User::setRoles<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#201\">App\\Entity\\User::getSalt<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#209\">App\\Entity\\User::getUsername<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#217\">App\\Entity\\User::eraseCredentials<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#222\">App\\Entity\\User::setUsername<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#229\">App\\Entity\\User::getFirstname<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#234\">App\\Entity\\User::setFirstname<\/a>"],[100,1,"<a href=\"Entity\/User.php.html#241\">App\\Entity\\User::getLastname<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#246\">App\\Entity\\User::setLastname<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#256\">App\\Entity\\User::getPreferences<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#265\">App\\Entity\\User::setPreferences<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#272\">App\\Entity\\User::getCreated<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#277\">App\\Entity\\User::setCreated<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#284\">App\\Entity\\User::getUpdated<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#289\">App\\Entity\\User::setUpdated<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#296\">App\\Entity\\User::getLastLogin<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#301\">App\\Entity\\User::setLastLogin<\/a>"],[0,1,"<a href=\"Entity\/User.php.html#311\">App\\Entity\\User::getPantries<\/a>"],[0,2,"<a href=\"Entity\/User.php.html#316\">App\\Entity\\User::addPantry<\/a>"],[0,2,"<a href=\"Entity\/User.php.html#326\">App\\Entity\\User::removePantry<\/a>"],[0,1,"<a href=\"Form\/NewPasswordType.php.html#13\">App\\Form\\NewPasswordType::buildForm<\/a>"],[100,1,"<a href=\"Form\/PantryType.php.html#12\">App\\Form\\PantryType::buildForm<\/a>"],[100,1,"<a href=\"Form\/PantryType.php.html#20\">App\\Form\\PantryType::configureOptions<\/a>"],[0,1,"<a href=\"Form\/PasswordChangeType.php.html#14\">App\\Form\\PasswordChangeType::buildForm<\/a>"],[0,1,"<a href=\"Form\/PasswordRequestType.php.html#12\">App\\Form\\PasswordRequestType::buildForm<\/a>"],[0,1,"<a href=\"Form\/ProductPresenceFilterType.php.html#13\">App\\Form\\ProductPresenceFilterType::buildForm<\/a>"],[0,1,"<a href=\"Form\/ProductPresenceFilterType.php.html#20\">App\\Form\\ProductPresenceFilterType::configureOptions<\/a>"],[0,1,"<a href=\"Form\/ProductPresenceType.php.html#16\">App\\Form\\ProductPresenceType::buildForm<\/a>"],[0,1,"<a href=\"Form\/ProductPresenceType.php.html#37\">App\\Form\\ProductPresenceType::configureOptions<\/a>"],[100,1,"<a href=\"Form\/UserLoginType.php.html#13\">App\\Form\\UserLoginType::buildForm<\/a>"],[100,1,"<a href=\"Form\/UserLoginType.php.html#20\">App\\Form\\UserLoginType::configureOptions<\/a>"],[100,1,"<a href=\"Form\/UserLoginType.php.html#28\">App\\Form\\UserLoginType::getBlockPrefix<\/a>"],[100,1,"<a href=\"Repository\/PantryRepository.php.html#16\">App\\Repository\\PantryRepository::__construct<\/a>"],[0,1,"<a href=\"Repository\/PantryRepository.php.html#22\">App\\Repository\\PantryRepository::findAllByUser<\/a>"],[0,1,"<a href=\"Repository\/ProductPresenceRepository.php.html#24\">App\\Repository\\ProductPresenceRepository::__construct<\/a>"],[0,3,"<a href=\"Repository\/ProductPresenceRepository.php.html#29\">App\\Repository\\ProductPresenceRepository::findAllByUser<\/a>"],[100,1,"<a href=\"Repository\/UserRepository.php.html#22\">App\\Repository\\UserRepository::__construct<\/a>"],[0,2,"<a href=\"Repository\/UserRepository.php.html#30\">App\\Repository\\UserRepository::upgradePassword<\/a>"],[80,3,"<a href=\"Security\/Voters\/PantryVoter.php.html#15\">App\\Security\\Voters\\PantryVoter::supports<\/a>"],[60,3,"<a href=\"Security\/Voters\/PantryVoter.php.html#27\">App\\Security\\Voters\\PantryVoter::voteOnAttribute<\/a>"],[75,3,"<a href=\"Security\/Voters\/PantryVoter.php.html#43\">App\\Security\\Voters\\PantryVoter::canManage<\/a>"]], 'Method Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getComplexityData(data, label) {
    var values = [];
    $.each(data, function(key) {
      var value = Math.round(data[key][0]*100) / 100;
      values.push({
        x: value,
        y: data[key][1],
        class: data[key][2],
        size: 0.05,
        shape: 'diamond'
      });
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
});
  </script>
 </body>
</html>
